function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
import lz4 from '../lib/lz4';
var WebTracker = _createClass(function WebTracker(opt) {
  var _this = this,
    _opt$protocol,
    _opt$source,
    _opt$headers;
  _classCallCheck(this, WebTracker);
  _defineProperty(this, "host", void 0);
  _defineProperty(this, "protocol", void 0);
  _defineProperty(this, "time", void 0);
  _defineProperty(this, "count", void 0);
  _defineProperty(this, "headers", void 0);
  _defineProperty(this, "timer", void 0);
  _defineProperty(this, "logs", void 0);
  _defineProperty(this, "projectId", void 0);
  _defineProperty(this, "topicId", void 0);
  _defineProperty(this, "source", void 0);
  _defineProperty(this, "compressType", void 0);
  _defineProperty(this, "correctTimeAndCount", function (num) {
    if (typeof num !== 'number') return 10;
    if (num < 1 || num > 20) {
      return 10;
    }
    return num;
  });
  _defineProperty(this, "objToQuery", function (obj) {
    if (!obj || _typeof(obj) !== 'object') return '';
    return Object.keys(obj).reduce(function (pre, cur) {
      var v = obj[cur];
      if (v === undefined || v === null) {
        return pre;
      }
      if (pre) {
        return "".concat(pre, "&").concat(cur, "=").concat(encodeURIComponent(v));
      }
      return "".concat(cur, "=").concat(encodeURIComponent(v));
    }, '');
  });
  _defineProperty(this, "handleQuery", function (url, params) {
    if (!params) return url;
    var query = _this.objToQuery(params);
    if (url.indexOf('?') !== -1) {
      var lastStr = url.substring(url.length - 1);
      if (lastStr === '&') {
        return "".concat(url).concat(query);
      }
      return "".concat(url, "&").concat(query);
    }
    return query ? "".concat(url, "?").concat(query) : url;
  });
  _defineProperty(this, "jsonStringify", function (obj) {
    try {
      return JSON.stringify(obj);
    } catch (err) {
      return "".concat(obj);
    }
  });
  _defineProperty(this, "handleRequestOptions", function (options) {
    var url = options.url,
      method = options.method,
      params = options.params;
    var body = _this.jsonStringify(options.body);
    var originBodyLength = lz4.Buffer.from(body).length;
    var lz4CompressError = false;
    try {
      body = _this.lz4Compress(body);
    } catch (e) {
      lz4CompressError = true;
    }
    var headers = _objectSpread({}, _this.headers);
    if (lz4CompressError) {
      headers['content-type'] = 'application/json';
    }
    if (!lz4CompressError) {
      headers['x-tls-bodyrawsize'] = "".concat(originBodyLength);
      headers['x-tls-compresstype'] = _this.compressType;
    }
    var resource = _this.handleQuery(url, params);
    return {
      url: resource,
      body: body,
      headers: headers,
      method: method
    };
  });
  _defineProperty(this, "requestByFetch", function (options) {
    var result = _this.handleRequestOptions(options);
    return fetch(result.url, {
      method: result.method,
      headers: result.headers,
      mode: 'cors',
      cache: 'no-store',
      body: result.body,
      keepalive: true
    }).then(function (response) {
      if (response.status !== 200) {
        throw new Error("Status: ".concat(response.status));
      }
    });
  });
  _defineProperty(this, "requestByXHR", function (options) {
    var result = _this.handleRequestOptions(options);
    return new Promise(function (resolve, reject) {
      var xhr = new XMLHttpRequest();
      xhr.open(result.method, result.url, true);
      xhr.onreadystatechange = function () {
        if (xhr.readyState === XMLHttpRequest.DONE) {
          if (xhr.status === 200) {
            resolve('');
            return;
          }
          var errObj = xhr.response;
          try {
            errObj = JSON.parse(errObj);
          } catch (e) {} finally {
            reject(errObj);
          }
        }
      };
      for (var k in result.headers) {
        xhr.setRequestHeader(k, result.headers[k]);
      }
      xhr.send(result.body);
    });
  });
  _defineProperty(this, "request", function (options) {
    var browserSupportsKeepalive = 'Request' in window && 'keepalive' in new Request('');
    if (browserSupportsKeepalive) {
      return _this.requestByFetch(options);
    }
    return _this.requestByXHR(options);
  });
  _defineProperty(this, "lz4Compress", function (input) {
    var innerInput = lz4.Buffer.from(input);
    var output = lz4.Buffer.alloc(lz4.LZ4.encodeBound(innerInput.length));
    var compressedSize = lz4.LZ4.encodeBlock(innerInput, output);
    output = output.slice(0, compressedSize);
    if (!compressedSize) throw new Error('no need to compress');
    return output;
  });
  _defineProperty(this, "transformObjValueToString", function (obj) {
    var newObj = {};
    for (var i in obj) {
      var v = obj[i];
      if (typeof v !== 'string') {
        newObj[i] = _this.jsonStringify(v);
      } else {
        newObj[i] = v;
      }
    }
    return newObj;
  });
  _defineProperty(this, "sendBatchLogsImmediateInner", function () {
    clearTimeout(_this.timer);
    _this.timer = -1;
    var Logs = _this.logs;
    _this.logs = [];
    return _this.request({
      url: "".concat(_this.protocol, "://").concat(_this.host, "/WebTracks"),
      params: {
        ProjectId: _this.projectId,
        TopicId: _this.topicId
      },
      body: {
        Logs: Logs,
        Source: _this.source
      },
      method: 'post'
    });
  });
  _defineProperty(this, "sendBatchLogsInner", function (options) {
    var _ref = options || {},
      onSuccess = _ref.onSuccess,
      onFail = _ref.onFail;
    if (_this.logs.length >= _this.count) {
      var Logs = _this.logs;
      _this.sendBatchLogsImmediateInner().then(function () {
        if (onSuccess) {
          onSuccess(Logs);
        }
      }).catch(function (err) {
        if (onFail) {
          onFail(Logs, err);
        }
      });
    } else if (_this.timer < 0) {
      _this.timer = window.setTimeout(function () {
        var Logs = _this.logs;
        _this.sendBatchLogsImmediateInner().then(function () {
          if (onSuccess) {
            onSuccess(Logs);
          }
        }).catch(function (err) {
          if (onFail) {
            onFail(Logs, err);
          }
        });
      }, _this.time * 1000);
    }
  });
  _defineProperty(this, "pushLogs", function (data) {
    var _this$logs;
    var newData = (data || []).map(function (d) {
      return _this.transformObjValueToString(d);
    });
    (_this$logs = _this.logs).push.apply(_this$logs, _toConsumableArray(newData));
  });
  _defineProperty(this, "send", function (data, options) {
    _this.sendBatchLogs([data], options);
  });
  _defineProperty(this, "sendImmediate", function (data) {
    return _this.sendBatchLogsImmediate([data]);
  });
  _defineProperty(this, "sendBatchLogs", function (data, options) {
    _this.pushLogs(data);
    return _this.sendBatchLogsInner(options || {});
  });
  _defineProperty(this, "sendBatchLogsImmediate", function (data) {
    _this.pushLogs(data);
    return _this.sendBatchLogsImmediateInner();
  });
  this.host = opt.host;
  this.protocol = (_opt$protocol = opt.protocol) !== null && _opt$protocol !== void 0 ? _opt$protocol : 'https';
  this.time = this.correctTimeAndCount(opt.time);
  this.count = this.correctTimeAndCount(opt.count);
  this.timer = -1;
  this.projectId = opt.projectId;
  this.topicId = opt.topicId;
  this.source = (_opt$source = opt.source) !== null && _opt$source !== void 0 ? _opt$source : '@volcengine/tls-js-sdk/webtracking';
  this.logs = [];
  this.headers = (_opt$headers = opt.headers) !== null && _opt$headers !== void 0 ? _opt$headers : {};
  this.compressType = 'lz4';
});
export default WebTracker;